Customising Cell and Row Group values Copy Link
By default, the values exported to Excel will be formatted via the Using the Value Formatter for Export feature.
The grid cell and row group values can be customised specifically for Excel export using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processCellCallback(params) {
const value = params.value
return value === undefined ? '' : `_${value}_`
},
processRowGroupCallback(params) {
return `row group: ${params.node.key}`
}
})See below the functions on the ExcelExportParams interface to customise exported grid cell and row group values.
A callback function invoked once per cell in the grid. Return a string value to be displayed in the export. For example this is useful for formatting date values.
|
A callback function invoked once per row group. Return a string to be displayed in the group cell.
|
The following example shows Excel customisations where the exported document has the following:
- All row groups with the prefix
row group: - All cell values surrounded by
_, unless they areundefined, in which case they are empty
When using row grouping while hiding open parents (groupHideOpenParents=true), export to Excel doesn't export the group rows as collapsible groups in Excel. Instead, all exported rows are on the same level and cannot be expanded/collapsed in Excel.
import {
ClientSideRowModelModule,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
ProcessCellForExportParams,
ProcessRowGroupForExportParams,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
const getParams: () => ExcelExportParams = () => ({
processCellCallback(params: ProcessCellForExportParams): string {
const value = params.value;
return value === undefined ? "" : `_${value}_`;
},
processRowGroupCallback(params: ProcessRowGroupForExportParams): string {
const { node } = params;
if (!node.footer) {
return `row group: ${node.key}`;
}
const isRootLevel = node.level === -1;
if (isRootLevel) {
return "Grand Total";
}
return `Sub Total (${node.key})`;
},
});
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200, rowGroup: true, hide: true },
{ field: "sport", minWidth: 150 },
{ field: "gold", aggFunc: "sum" },
],
defaultColDef: {
filter: true,
minWidth: 150,
flex: 1,
},
groupTotalRow: "bottom",
grandTotalRow: "bottom",
popupParent: document.body,
defaultExcelExportParams: getParams(),
};
function onBtExport() {
gridApi!.exportDataAsExcel(getParams());
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((response) => response.json())
.then((data) =>
gridApi!.setGridOption(
"rowData",
data.filter((rec: any) => rec.country != null),
),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
<div class="container">
<div>
<button onclick="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Customising Column Headers and Group Header Values Copy Link
The column headers and group headers exported to Excel can be customised using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processGroupHeaderCallback(params) {
return `group header: ${params.api.getDisplayNameForColumnGroup(params.columnGroup, null)}`
},
processHeaderCallback(params) {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`
}
});See below the functions on the ExcelExportParams interface to customise exported column group headers and headers.
A callback function invoked once per column. Return a string to be displayed in the column header.
|
A callback function invoked once per column group. Return a string to be displayed in the column group header. Note that column groups are exported by default, this option will not work with skipColumnGroupHeaders=true.
|
The following example shows Excel customisations where the exported document has the following:
- Group headers with the prefix
group header: - Headers with the prefix
header:
import {
ClientSideRowModelModule,
ColumnApiModule,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
ProcessGroupHeaderForExportParams,
ProcessHeaderForExportParams,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{
headerName: "Athlete details",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 150 },
{ field: "sport", minWidth: 150 },
],
},
{
headerName: "Medal results",
children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
},
],
defaultColDef: {
filter: true,
minWidth: 100,
flex: 1,
},
popupParent: document.body,
};
const getParams: () => ExcelExportParams = () => ({
processHeaderCallback(params: ProcessHeaderForExportParams): string {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`;
},
processGroupHeaderCallback(
params: ProcessGroupHeaderForExportParams,
): string {
return `group header: ${params.api.getDisplayNameForColumnGroup(params.columnGroup, null)}`;
},
});
function onBtExport() {
gridApi!.exportDataAsExcel(getParams());
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((response) => response.json())
.then((data) =>
gridApi!.setGridOption(
"rowData",
data.filter((rec: any) => rec.country != null),
),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
<div class="container">
<div>
<button onclick="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Custom Metadata Copy Link
Use customMetadata to write custom document properties to the exported file. The values are added as metadata to the Excel file and serialised as strings.
This is useful for attaching internal identifiers, workflow hints, or metadata consumed by downstream systems.
Use cases for custom metadata may include:
- Internal workflow tagging (for example, adding
ExportIDorGeneratedByfor tracking in automation scripts). - Integration with document management systems (for example, embedding
ContractTypeorExpirationDatefor indexing in SharePoint or similar tools). - Integration with third-party analytics tools (for example, passing
CampaignIDfor BI dashboard automation).
gridApi.exportDataAsExcel({
customMetadata: {
ExportID: 'EXP-2026-001',
ExpirationDate: '2025-01-01T12:00:00Z',
Disclaimer: 'Preliminary data; subject to audit',
},
});Properties available on the ExcelExportParams interface.
Custom metadata to write to docProps/custom.xml in the exported file. Values are serialised as strings.
|
The Grid does not interpret these values or apply labels; it only writes the custom properties provided in the customMetadata parameter. This feature does not replace or integrate with officially endorsed labelling systems, such as Microsoft Purview Sensitivity Labels, which require specific SDKs or APIs for enforcement, encryption, and compliance.
import {
ClientSideRowModelModule,
CsvExportModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
NumberFilterModule,
TextFilterModule,
]);
interface ReportRow {
department: string;
reportId: string;
owner: string;
cost: number;
}
const rowData: ReportRow[] = [
{ department: "Security", reportId: "RPT-001", owner: "Morgan", cost: 1200 },
{ department: "Finance", reportId: "RPT-014", owner: "Avery", cost: 5400 },
{
department: "Operations",
reportId: "RPT-082",
owner: "Jordan",
cost: 3100,
},
{ department: "Legal", reportId: "RPT-109", owner: "Taylor", cost: 2700 },
];
const customMetadata = {
ExportID: "EXP-2026-001",
ExpirationDate: "2025-01-01T12:00:00Z",
Disclaimer: "Preliminary data; subject to audit",
};
let gridApi: GridApi<ReportRow>;
const gridOptions: GridOptions<ReportRow> = {
columnDefs: [
{ field: "department", minWidth: 160 },
{ field: "reportId", minWidth: 140 },
{ field: "owner", minWidth: 140 },
{ field: "cost", filter: "agNumberColumnFilter", minWidth: 120 },
],
defaultColDef: {
filter: true,
flex: 1,
minWidth: 120,
},
rowData,
defaultExcelExportParams: {
customMetadata: customMetadata,
},
};
function onBtExport() {
gridApi!.exportDataAsExcel();
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
<div class="container">
<div>
<button onclick="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>

Customising Cell and Row Group values Copy Link
By default, the values exported to Excel will be formatted via the Using the Value Formatter for Export feature.
The grid cell and row group values can be customised specifically for Excel export using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processCellCallback(params) {
const value = params.value
return value === undefined ? '' : `_${value}_`
},
processRowGroupCallback(params) {
return `row group: ${params.node.key}`
}
})See below the functions on the ExcelExportParams interface to customise exported grid cell and row group values.
A callback function invoked once per cell in the grid. Return a string value to be displayed in the export. For example this is useful for formatting date values.
|
A callback function invoked once per row group. Return a string to be displayed in the group cell.
|
The following example shows Excel customisations where the exported document has the following:
- All row groups with the prefix
row group: - All cell values surrounded by
_, unless they areundefined, in which case they are empty
When using row grouping while hiding open parents (groupHideOpenParents=true), export to Excel doesn't export the group rows as collapsible groups in Excel. Instead, all exported rows are on the same level and cannot be expanded/collapsed in Excel.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
ProcessCellForExportParams,
ProcessRowGroupForExportParams,
UseGroupTotalRow,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="container">
<div>
<button (click)="onBtExport()" style="margin: 5px 0px; font-weight: bold">
Export to Excel
</button>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[groupTotalRow]="groupTotalRow"
[grandTotalRow]="grandTotalRow"
[popupParent]="popupParent"
[defaultExcelExportParams]="defaultExcelExportParams"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200, rowGroup: true, hide: true },
{ field: "sport", minWidth: 150 },
{ field: "gold", aggFunc: "sum" },
];
defaultColDef: ColDef = {
filter: true,
minWidth: 150,
flex: 1,
};
groupTotalRow: "top" | "bottom" | UseGroupTotalRow = "bottom";
grandTotalRow: "top" | "bottom" | "pinnedTop" | "pinnedBottom" = "bottom";
popupParent: HTMLElement | null = document.body;
defaultExcelExportParams: ExcelExportParams = getParams();
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtExport() {
this.gridApi.exportDataAsExcel(getParams());
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe(
(data) =>
(this.rowData = data.filter((rec: any) => rec.country != null)),
);
}
}
const getParams: () => ExcelExportParams = () => ({
processCellCallback(params: ProcessCellForExportParams): string {
const value = params.value;
return value === undefined ? "" : `_${value}_`;
},
processRowGroupCallback(params: ProcessRowGroupForExportParams): string {
const { node } = params;
if (!node.footer) {
return `row group: ${node.key}`;
}
const isRootLevel = node.level === -1;
if (isRootLevel) {
return "Grand Total";
}
return `Sub Total (${node.key})`;
},
});
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Customising Column Headers and Group Header Values Copy Link
The column headers and group headers exported to Excel can be customised using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processGroupHeaderCallback(params) {
return `group header: ${params.this.gridApi.getDisplayNameForColumnGroup(params.columnGroup, null)}`
},
processHeaderCallback(params) {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`
}
});See below the functions on the ExcelExportParams interface to customise exported column group headers and headers.
A callback function invoked once per column. Return a string to be displayed in the column header.
|
A callback function invoked once per column group. Return a string to be displayed in the column group header. Note that column groups are exported by default, this option will not work with skipColumnGroupHeaders=true.
|
The following example shows Excel customisations where the exported document has the following:
- Group headers with the prefix
group header: - Headers with the prefix
header:
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
ProcessGroupHeaderForExportParams,
ProcessHeaderForExportParams,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="container">
<div>
<button (click)="onBtExport()" style="margin: 5px 0px; font-weight: bold">
Export to Excel
</button>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[popupParent]="popupParent"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: (ColDef | ColGroupDef)[] = [
{
headerName: "Athlete details",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 150 },
{ field: "sport", minWidth: 150 },
],
},
{
headerName: "Medal results",
children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
},
];
defaultColDef: ColDef = {
filter: true,
minWidth: 100,
flex: 1,
};
popupParent: HTMLElement | null = document.body;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtExport() {
this.gridApi.exportDataAsExcel(getParams());
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe(
(data) =>
(this.rowData = data.filter((rec: any) => rec.country != null)),
);
}
}
const getParams: () => ExcelExportParams = () => ({
processHeaderCallback(params: ProcessHeaderForExportParams): string {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`;
},
processGroupHeaderCallback(
params: ProcessGroupHeaderForExportParams,
): string {
return `group header: ${params.api.getDisplayNameForColumnGroup(params.columnGroup, null)}`;
},
});
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Custom Metadata Copy Link
Use customMetadata to write custom document properties to the exported file. The values are added as metadata to the Excel file and serialised as strings.
This is useful for attaching internal identifiers, workflow hints, or metadata consumed by downstream systems.
Use cases for custom metadata may include:
- Internal workflow tagging (for example, adding
ExportIDorGeneratedByfor tracking in automation scripts). - Integration with document management systems (for example, embedding
ContractTypeorExpirationDatefor indexing in SharePoint or similar tools). - Integration with third-party analytics tools (for example, passing
CampaignIDfor BI dashboard automation).
gridApi.exportDataAsExcel({
customMetadata: {
ExportID: 'EXP-2026-001',
ExpirationDate: '2025-01-01T12:00:00Z',
Disclaimer: 'Preliminary data; subject to audit',
},
});Properties available on the ExcelExportParams interface.
Custom metadata to write to docProps/custom.xml in the exported file. Values are serialised as strings.
|
The Grid does not interpret these values or apply labels; it only writes the custom properties provided in the customMetadata parameter. This feature does not replace or integrate with officially endorsed labelling systems, such as Microsoft Purview Sensitivity Labels, which require specific SDKs or APIs for enforcement, encryption, and compliance.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
NumberFilterModule,
TextFilterModule,
]);
interface ReportRow {
department: string;
reportId: string;
owner: string;
cost: number;
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="container">
<div>
<button (click)="onBtExport()" style="margin: 5px 0px; font-weight: bold">
Export to Excel
</button>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[rowData]="rowData"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[defaultExcelExportParams]="defaultExcelExportParams"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<ReportRow>;
rowData: ReportRow[] | null = [
{
department: "Security",
reportId: "RPT-001",
owner: "Morgan",
cost: 1200,
},
{ department: "Finance", reportId: "RPT-014", owner: "Avery", cost: 5400 },
{
department: "Operations",
reportId: "RPT-082",
owner: "Jordan",
cost: 3100,
},
{ department: "Legal", reportId: "RPT-109", owner: "Taylor", cost: 2700 },
];
columnDefs: ColDef[] = [
{ field: "department", minWidth: 160 },
{ field: "reportId", minWidth: 140 },
{ field: "owner", minWidth: 140 },
{ field: "cost", filter: "agNumberColumnFilter", minWidth: 120 },
];
defaultColDef: ColDef = {
filter: true,
flex: 1,
minWidth: 120,
};
defaultExcelExportParams: ExcelExportParams = {
customMetadata: customMetadata,
};
onBtExport() {
this.gridApi.exportDataAsExcel();
}
onGridReady(params: GridReadyEvent<ReportRow>) {
this.gridApi = params.api;
}
}
const customMetadata = {
ExportID: "EXP-2026-001",
ExpirationDate: "2025-01-01T12:00:00Z",
Disclaimer: "Preliminary data; subject to audit",
};
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});

Customising Cell and Row Group values Copy Link
By default, the values exported to Excel will be formatted via the Using the Value Formatter for Export feature.
The grid cell and row group values can be customised specifically for Excel export using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processCellCallback(params) {
const value = params.value
return value === undefined ? '' : `_${value}_`
},
processRowGroupCallback(params) {
return `row group: ${params.node.key}`
}
})See below the functions on the ExcelExportParams interface to customise exported grid cell and row group values.
A callback function invoked once per cell in the grid. Return a string value to be displayed in the export. For example this is useful for formatting date values.
|
A callback function invoked once per row group. Return a string to be displayed in the group cell.
|
The following example shows Excel customisations where the exported document has the following:
- All row groups with the prefix
row group: - All cell values surrounded by
_, unless they areundefined, in which case they are empty
When using row grouping while hiding open parents (groupHideOpenParents=true), export to Excel doesn't export the group rows as collapsible groups in Excel. Instead, all exported rows are on the same level and cannot be expanded/collapsed in Excel.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
ProcessCellForExportParams,
ProcessRowGroupForExportParams,
UseGroupTotalRow,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
const getParams: () => ExcelExportParams = () => ({
processCellCallback(params: ProcessCellForExportParams): string {
const value = params.value;
return value === undefined ? "" : `_${value}_`;
},
processRowGroupCallback(params: ProcessRowGroupForExportParams): string {
const { node } = params;
if (!node.footer) {
return `row group: ${node.key}`;
}
const isRootLevel = node.level === -1;
if (isRootLevel) {
return "Grand Total";
}
return `Sub Total (${node.key})`;
},
});
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div>
<button v-on:click="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:groupTotalRow="groupTotalRow"
:grandTotalRow="grandTotalRow"
:popupParent="popupParent"
:defaultExcelExportParams="defaultExcelExportParams"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200, rowGroup: true, hide: true },
{ field: "sport", minWidth: 150 },
{ field: "gold", aggFunc: "sum" },
]);
const defaultColDef = ref<ColDef>({
filter: true,
minWidth: 150,
flex: 1,
});
const groupTotalRow = ref<"top" | "bottom" | UseGroupTotalRow>("bottom");
const grandTotalRow = ref<"top" | "bottom" | "pinnedTop" | "pinnedBottom">(
"bottom",
);
const popupParent = ref<HTMLElement | null>(document.body);
const defaultExcelExportParams = ref<ExcelExportParams>(getParams());
const rowData = ref<IOlympicData[]>(null);
function onBtExport() {
gridApi.value!.exportDataAsExcel(getParams());
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) =>
(rowData.value = data.filter((rec: any) => rec.country != null));
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
groupTotalRow,
grandTotalRow,
popupParent,
defaultExcelExportParams,
rowData,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
Customising Column Headers and Group Header Values Copy Link
The column headers and group headers exported to Excel can be customised using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processGroupHeaderCallback(params) {
return `group header: ${params.this.gridApi.getDisplayNameForColumnGroup(params.columnGroup, null)}`
},
processHeaderCallback(params) {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`
}
});See below the functions on the ExcelExportParams interface to customise exported column group headers and headers.
A callback function invoked once per column. Return a string to be displayed in the column header.
|
A callback function invoked once per column group. Return a string to be displayed in the column group header. Note that column groups are exported by default, this option will not work with skipColumnGroupHeaders=true.
|
The following example shows Excel customisations where the exported document has the following:
- Group headers with the prefix
group header: - Headers with the prefix
header:
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
ProcessGroupHeaderForExportParams,
ProcessHeaderForExportParams,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
const getParams: () => ExcelExportParams = () => ({
processHeaderCallback(params: ProcessHeaderForExportParams): string {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`;
},
processGroupHeaderCallback(
params: ProcessGroupHeaderForExportParams,
): string {
return `group header: ${params.api.getDisplayNameForColumnGroup(params.columnGroup, null)}`;
},
});
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div>
<button v-on:click="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:popupParent="popupParent"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<(ColDef | ColGroupDef)[]>([
{
headerName: "Athlete details",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 150 },
{ field: "sport", minWidth: 150 },
],
},
{
headerName: "Medal results",
children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
},
]);
const defaultColDef = ref<ColDef>({
filter: true,
minWidth: 100,
flex: 1,
});
const popupParent = ref<HTMLElement | null>(document.body);
const rowData = ref<IOlympicData[]>(null);
function onBtExport() {
gridApi.value!.exportDataAsExcel(getParams());
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) =>
(rowData.value = data.filter((rec: any) => rec.country != null));
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
popupParent,
rowData,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
Custom Metadata Copy Link
Use customMetadata to write custom document properties to the exported file. The values are added as metadata to the Excel file and serialised as strings.
This is useful for attaching internal identifiers, workflow hints, or metadata consumed by downstream systems.
Use cases for custom metadata may include:
- Internal workflow tagging (for example, adding
ExportIDorGeneratedByfor tracking in automation scripts). - Integration with document management systems (for example, embedding
ContractTypeorExpirationDatefor indexing in SharePoint or similar tools). - Integration with third-party analytics tools (for example, passing
CampaignIDfor BI dashboard automation).
gridApi.exportDataAsExcel({
customMetadata: {
ExportID: 'EXP-2026-001',
ExpirationDate: '2025-01-01T12:00:00Z',
Disclaimer: 'Preliminary data; subject to audit',
},
});Properties available on the ExcelExportParams interface.
Custom metadata to write to docProps/custom.xml in the exported file. Values are serialised as strings.
|
The Grid does not interpret these values or apply labels; it only writes the custom properties provided in the customMetadata parameter. This feature does not replace or integrate with officially endorsed labelling systems, such as Microsoft Purview Sensitivity Labels, which require specific SDKs or APIs for enforcement, encryption, and compliance.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
NumberFilterModule,
TextFilterModule,
]);
interface ReportRow {
department: string;
reportId: string;
owner: string;
cost: number;
}
const customMetadata = {
ExportID: "EXP-2026-001",
ExpirationDate: "2025-01-01T12:00:00Z",
Disclaimer: "Preliminary data; subject to audit",
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div>
<button v-on:click="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:rowData="rowData"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<ReportRow> | null>(null);
const rowData = ref<ReportRow[] | null>([
{
department: "Security",
reportId: "RPT-001",
owner: "Morgan",
cost: 1200,
},
{
department: "Finance",
reportId: "RPT-014",
owner: "Avery",
cost: 5400,
},
{
department: "Operations",
reportId: "RPT-082",
owner: "Jordan",
cost: 3100,
},
{ department: "Legal", reportId: "RPT-109", owner: "Taylor", cost: 2700 },
]);
const columnDefs = ref<ColDef[]>([
{ field: "department", minWidth: 160 },
{ field: "reportId", minWidth: 140 },
{ field: "owner", minWidth: 140 },
{ field: "cost", filter: "agNumberColumnFilter", minWidth: 120 },
]);
const defaultColDef = ref<ColDef>({
filter: true,
flex: 1,
minWidth: 120,
});
const defaultExcelExportParams = ref<ExcelExportParams>({
customMetadata: customMetadata,
});
function onBtExport() {
gridApi.value!.exportDataAsExcel();
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
rowData,
columnDefs,
defaultColDef,
defaultExcelExportParams,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}

Customising Cell and Row Group values Copy Link
By default, the values exported to Excel will be formatted via the Using the Value Formatter for Export feature.
The grid cell and row group values can be customised specifically for Excel export using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processCellCallback(params) {
const value = params.value
return value === undefined ? '' : `_${value}_`
},
processRowGroupCallback(params) {
return `row group: ${params.node.key}`
}
})See below the functions on the ExcelExportParams interface to customise exported grid cell and row group values.
A callback function invoked once per cell in the grid. Return a string value to be displayed in the export. For example this is useful for formatting date values.
|
A callback function invoked once per row group. Return a string to be displayed in the group cell.
|
The following example shows Excel customisations where the exported document has the following:
- All row groups with the prefix
row group: - All cell values surrounded by
_, unless they areundefined, in which case they are empty
When using row grouping while hiding open parents (groupHideOpenParents=true), export to Excel doesn't export the group rows as collapsible groups in Excel. Instead, all exported rows are on the same level and cannot be expanded/collapsed in Excel.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
ProcessCellForExportParams,
ProcessRowGroupForExportParams,
UseGroupTotalRow,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
];
const getParams: () => ExcelExportParams = () => ({
processCellCallback(params: ProcessCellForExportParams): string {
const value = params.value;
return value === undefined ? "" : `_${value}_`;
},
processRowGroupCallback(params: ProcessRowGroupForExportParams): string {
const { node } = params;
if (!node.footer) {
return `row group: ${node.key}`;
}
const isRootLevel = node.level === -1;
if (isRootLevel) {
return "Grand Total";
}
return `Sub Total (${node.key})`;
},
});
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicData[]>();
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200, rowGroup: true, hide: true },
{ field: "sport", minWidth: 150 },
{ field: "gold", aggFunc: "sum" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
filter: true,
minWidth: 150,
flex: 1,
};
}, []);
const popupParent = useMemo<HTMLElement | null>(() => {
return document.body;
}, []);
const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
return getParams();
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) =>
setRowData(data.filter((rec: any) => rec.country != null)),
);
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel(getParams());
}, [getParams]);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div>
<button
onClick={onBtExport}
style={{ margin: "5px 0px", fontWeight: "bold" }}
>
Export to Excel
</button>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
groupTotalRow={"bottom"}
grandTotalRow={"bottom"}
popupParent={popupParent}
defaultExcelExportParams={defaultExcelExportParams}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Customising Column Headers and Group Header Values Copy Link
The column headers and group headers exported to Excel can be customised using the following function params for a call to exportDataAsExcel API method or in the defaultExcelExportParams.
gridApi.exportDataAsExcel({
processGroupHeaderCallback(params) {
return `group header: ${params.gridApi.getDisplayNameForColumnGroup(params.columnGroup, null)}`
},
processHeaderCallback(params) {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`
}
});See below the functions on the ExcelExportParams interface to customise exported column group headers and headers.
A callback function invoked once per column. Return a string to be displayed in the column header.
|
A callback function invoked once per column group. Return a string to be displayed in the column group header. Note that column groups are exported by default, this option will not work with skipColumnGroupHeaders=true.
|
The following example shows Excel customisations where the exported document has the following:
- Group headers with the prefix
group header: - Headers with the prefix
header:
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
ProcessGroupHeaderForExportParams,
ProcessHeaderForExportParams,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ColumnApiModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
];
const getParams: () => ExcelExportParams = () => ({
processHeaderCallback(params: ProcessHeaderForExportParams): string {
return `header: ${params.api.getDisplayNameForColumn(params.column, null)}`;
},
processGroupHeaderCallback(
params: ProcessGroupHeaderForExportParams,
): string {
return `group header: ${params.api.getDisplayNameForColumnGroup(params.columnGroup, null)}`;
},
});
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicData[]>();
const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
{
headerName: "Athlete details",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 150 },
{ field: "sport", minWidth: 150 },
],
},
{
headerName: "Medal results",
children: [{ field: "gold" }, { field: "silver" }, { field: "bronze" }],
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
filter: true,
minWidth: 100,
flex: 1,
};
}, []);
const popupParent = useMemo<HTMLElement | null>(() => {
return document.body;
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) =>
setRowData(data.filter((rec: any) => rec.country != null)),
);
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel(getParams());
}, [getParams]);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div>
<button
onClick={onBtExport}
style={{ margin: "5px 0px", fontWeight: "bold" }}
>
Export to Excel
</button>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
popupParent={popupParent}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Custom Metadata Copy Link
Use customMetadata to write custom document properties to the exported file. The values are added as metadata to the Excel file and serialised as strings.
This is useful for attaching internal identifiers, workflow hints, or metadata consumed by downstream systems.
Use cases for custom metadata may include:
- Internal workflow tagging (for example, adding
ExportIDorGeneratedByfor tracking in automation scripts). - Integration with document management systems (for example, embedding
ContractTypeorExpirationDatefor indexing in SharePoint or similar tools). - Integration with third-party analytics tools (for example, passing
CampaignIDfor BI dashboard automation).
gridApi.exportDataAsExcel({
customMetadata: {
ExportID: 'EXP-2026-001',
ExpirationDate: '2025-01-01T12:00:00Z',
Disclaimer: 'Preliminary data; subject to audit',
},
});Properties available on the ExcelExportParams interface.
Custom metadata to write to docProps/custom.xml in the exported file. Values are serialised as strings.
|
The Grid does not interpret these values or apply labels; it only writes the custom properties provided in the customMetadata parameter. This feature does not replace or integrate with officially endorsed labelling systems, such as Microsoft Purview Sensitivity Labels, which require specific SDKs or APIs for enforcement, encryption, and compliance.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelExportParams,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
NumberFilterModule,
TextFilterModule,
];
interface ReportRow {
department: string;
reportId: string;
owner: string;
cost: number;
}
const customMetadata = {
ExportID: "EXP-2026-001",
ExpirationDate: "2025-01-01T12:00:00Z",
Disclaimer: "Preliminary data; subject to audit",
};
const GridExample = () => {
const gridRef = useRef<AgGridReact<ReportRow>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<ReportRow[]>([
{
department: "Security",
reportId: "RPT-001",
owner: "Morgan",
cost: 1200,
},
{ department: "Finance", reportId: "RPT-014", owner: "Avery", cost: 5400 },
{
department: "Operations",
reportId: "RPT-082",
owner: "Jordan",
cost: 3100,
},
{ department: "Legal", reportId: "RPT-109", owner: "Taylor", cost: 2700 },
]);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "department", minWidth: 160 },
{ field: "reportId", minWidth: 140 },
{ field: "owner", minWidth: 140 },
{ field: "cost", filter: "agNumberColumnFilter", minWidth: 120 },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
filter: true,
flex: 1,
minWidth: 120,
};
}, []);
const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
return {
customMetadata: customMetadata,
};
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel();
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div>
<button
onClick={onBtExport}
style={{ margin: "5px 0px", fontWeight: "bold" }}
>
Export to Excel
</button>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact<ReportRow>
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
defaultExcelExportParams={defaultExcelExportParams}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}